# class Window

#### package js.html

#### extends EventTarget

Available on HTML5

The `window` object represents a window containing a DOM document; the `document` property points to the DOM document loaded in that window.

Documentation Window by Mozilla Contributors, licensed under CC-BY-SA 2.5.

See:

https://developer.mozilla.org/en-US/docs/Web/API/Window

### Variables

###

`read onlyclosed:Bool`

This property indicates whether the current window is closed or not.

###

`read onlyconsole:Console`

Returns a reference to the console object which provides access to the browser's debugging console.

###

`read onlycontent:Dynamic`

Returns a reference to the content element in the current window. The obsolete variant with underscore is no longer available from Web content.

###

`read onlycrypto:Crypto`

Returns the browser crypto object.

###

`read onlydevicePixelRatio:Float`

Returns the ratio between physical pixels and device independent pixels in the current display.

###

`read onlydocument:HTMLDocument`

Returns a reference to the document that the window contains.

###

`read onlyframeElement:Element`

Returns the element in which the window is embedded, or null if the window is not embedded.

###

`read onlyframes:Window`

Returns an array of the subframes in the current window.

###

`fullScreen:Bool`

This property indicates whether the window is displayed in full screen or not.

###

`read onlyhistory:History`

Returns a reference to the history object.

###

`read onlyindexedDB:Factory`

###

`innerHeight:Dynamic`

Gets the height of the content area of the browser window including, if rendered, the horizontal scrollbar.

###

`innerWidth:Dynamic`

Gets the width of the content area of the browser window including, if rendered, the vertical scrollbar.

###

`read onlylength:Int`

Returns the number of frames in the window. See also `window.frames`.

###

`read onlylocalStorage:Storage`

Returns a reference to the local storage object used to store data that may only be accessed by the origin that created it.

###

`read onlylocation:Location`

Gets/sets the location, or current URL, of the window object.

###

`read onlylocationbar:BarProp`

Returns the locationbar object, whose visibility can be toggled in the window.

###

`read onlymenubar:BarProp`

Returns the menubar object, whose visibility can be toggled in the window.

###

`name:String`

Gets/sets the name of the window.

###

`read onlynavigator:Navigator`

Returns a reference to the navigator object.

###

`onabort:Function`

###

`onabsolutedeviceorientation:Function`

###

`onafterprint:Function`

###

`onbeforeprint:Function`

###

`onblur:Function`

###

`oncanplay:Function`

###

`oncanplaythrough:Function`

###

`onchange:Function`

###

`onclick:Function`

###

`oncontextmenu:Function`

###

`ondblclick:Function`

###

`ondevicelight:Function`

###

`ondevicemotion:Function`

###

`ondeviceorientation:Function`

###

`ondeviceproximity:Function`

###

`ondrag:Function`

###

`ondragend:Function`

###

`ondragenter:Function`

###

`ondragleave:Function`

###

`ondragover:Function`

###

`ondragstart:Function`

###

`ondrop:Function`

###

`ondurationchange:Function`

###

`onemptied:Function`

###

`onended:Function`

###

`onfocus:Function`

###

`onfullscreenchange:Function`

###

`onfullscreenerror:Function`

###

`ongotpointercapture:Function`

###

`onhashchange:Function`

###

`oninput:Function`

###

`oninvalid:Function`

###

`onkeydown:Function`

###

`onkeypress:Function`

###

`onkeyup:Function`

###

`onlanguagechange:Function`

###

`onload:Function`

###

`onloadeddata:Function`

###

`onloadedmetadata:Function`

###

`onloadstart:Function`

###

`onlostpointercapture:Function`

###

`onmessage:Function`

###

`onmousedown:Function`

###

`onmouseenter:Function`

###

`onmouseleave:Function`

###

`onmousemove:Function`

###

`onmouseout:Function`

###

`onmouseover:Function`

###

`onmouseup:Function`

###

`onoffline:Function`

###

`ononline:Function`

###

`onorientationchange:Function`

###

`onpagehide:Function`

###

`onpageshow:Function`

###

`onpause:Function`

###

`onplay:Function`

###

`onplaying:Function`

###

`onpointercancel:Function`

###

`onpointerdown:Function`

###

`onpointerenter:Function`

###

`onpointerleave:Function`

###

`onpointerlockchange:Function`

###

`onpointerlockerror:Function`

###

`onpointermove:Function`

###

`onpointerout:Function`

###

`onpointerover:Function`

###

`onpointerup:Function`

###

`onpopstate:Function`

###

`onprogress:Function`

###

`onratechange:Function`

###

`onreset:Function`

###

`onresize:Function`

###

`onscroll:Function`

###

`onseeked:Function`

###

`onseeking:Function`

###

`onselect:Function`

###

`onshow:Function`

###

`onstalled:Function`

###

`onstorage:Function`

###

`onsubmit:Function`

###

`onsuspend:Function`

###

`ontimeupdate:Function`

###

`ontouchcancel:Function`

###

`ontouchend:Function`

###

`ontouchmove:Function`

###

`ontouchstart:Function`

###

`onunload:Function`

###

`onuserproximity:Function`

###

`onvolumechange:Function`

###

`onwaiting:Function`

###

`onwheel:Function`

###

`opener:Dynamic`

Returns a reference to the window that opened this current window.

###

`read onlyorientation:Int`

Returns the orientation in degrees (in 90 degree increments) of the viewport relative to the device's natural orientation.

###

`outerHeight:Dynamic`

Gets the height of the outside of the browser window.

###

`outerWidth:Dynamic`

Gets the width of the outside of the browser window.

###

`read onlypageXOffset:Int`

###

`read onlypageYOffset:Int`

###

`read onlyparent:Window`

Returns a reference to the parent of the current window or subframe.

###

`read onlyperformance:Performance`

Provides a hosting area for performance related attributes.

###

`read onlypersonalbar:BarProp`

Returns the personalbar object, whose visibility can be toggled in the window.

###

`read onlyscreen:Screen`

Returns a reference to the screen object associated with the window.

###

`screenX:Dynamic`

Returns the horizontal distance of the left border of the user's browser from the left side of the screen.

###

`screenY:Dynamic`

Returns the vertical distance of the top border of the user's browser from the top side of the screen.

###

`read onlyscrollMaxX:Int`

The maximum offset that the window can be scrolled to horizontally, that is the document width minus the viewport width.

###

`read onlyscrollMaxY:Int`

The maximum offset that the window can be scrolled to vertically (i.e., the document height minus the viewport height).

###

`read onlyscrollX:Int`

Returns the number of pixels that the document has already been scrolled horizontally.

###

`read onlyscrollY:Int`

Returns the number of pixels that the document has already been scrolled vertically.

###

`read onlyscrollbars:BarProp`

Returns the scrollbars object, whose visibility can be toggled in the window.

###

`read onlyself:Window`

Returns an object reference to the window object itself.

###

`read onlysessionStorage:Storage`

Returns a storage object for storing data within a single page session.

###

`read onlyspeechSynthesis:SpeechSynthesis`

Returns a `SpeechSynthesis` object, which is the entry point into using Web Speech API speech synthesis functionality.

###

`status:String`

Gets/sets the text in the statusbar at the bottom of the browser.

###

`read onlystatusbar:BarProp`

Returns the statusbar object, whose visibility can be toggled in the window.

###

`read onlytoolbar:BarProp`

Returns the toolbar object, whose visibility can be toggled in the window.

###

`read onlytop:Window`

Returns a reference to the topmost window in the window hierarchy. This property is read only.

###

`read onlywindow:Window`

Returns a reference to the current window.

###

`onbeforeunload:Event ‑> String`

###

`onerror:EitherType<Event, String> ‑> String ‑> Int ‑> Int ‑> Dynamic ‑> Bool`

### Methods

###

`alert (message:String):Void`

`alert ():Void`

Throws:

`null` | DOMError

###

`atob (atob:String):String`

Throws:

`null` | DOMError

###

`blur ():Void`

Throws:

`null` | DOMError

###

`btoa (btoa:String):String`

Throws:

`null` | DOMError

###

`cancelAnimationFrame (handle:Int):Void`

Throws:

`null` | DOMError

###

`captureEvents ():Void`

Registers the window to capture all events of the specified type.

###

`clearInterval (handle:Int = 0):Void`

###

`clearTimeout (handle:Int = 0):Void`

###

`close ():Void`

Throws:

`null` | DOMError

###

`confirm (message:String = ""):Bool`

Throws:

`null` | DOMError

###

`createImageBitmap (aImage:EitherType<ImageElement, EitherType<VideoElement, EitherType<CanvasElement, EitherType<Blob, EitherType<ImageData, EitherType<CanvasRenderingContext2D, ImageBitmap>>>>>>, aSx:Int, aSy:Int, aSw:Int, aSh:Int):Promise<ImageBitmap>`

`createImageBitmap (aImage:EitherType<ImageElement, EitherType<VideoElement, EitherType<CanvasElement, EitherType<Blob, EitherType<ImageData, EitherType<CanvasRenderingContext2D, ImageBitmap>>>>>>):Promise<ImageBitmap>`

Throws:

`null` | DOMError

###

`dump (str:String):Void`

Writes a message to the console.

###

`fetch (input:EitherType<Request, String>, ?init:RequestInit):Promise<Response>`

Throws:

`null` | DOMError

###

`find (str:String = "", caseSensitive:Bool = false, backwards:Bool = false, wrapAround:Bool = false, wholeWord:Bool = false, searchInFrames:Bool = false, showDialog:Bool = false):Bool`

Throws:

`null` | DOMError

###

`focus ():Void`

Throws:

`null` | DOMError

###

`getComputedStyle (elt:Element, pseudoElt:String = ""):CSSStyleDeclaration`

Throws:

`null` | DOMError

###

`getDefaultComputedStyle (elt:Element, pseudoElt:String = ""):CSSStyleDeclaration`

Throws:

`null` | DOMError

###

`getSelection ():Selection`

Throws:

`null` | DOMError

###

`matchMedia (query:String):MediaQueryList`

Throws:

`null` | DOMError

###

`moveBy (x:Int, y:Int):Void`

Throws:

`null` | DOMError

###

`moveTo (x:Int, y:Int):Void`

Throws:

`null` | DOMError

###

`open (url:String = "", target:String = "", features:String = ""):Window`

Throws:

`null` | DOMError

###

`postMessage (message:Dynamic, targetOrigin:String, ?transfer:Array<Dynamic>):Void`

Throws:

`null` | DOMError

###

`print ():Void`

Throws:

`null` | DOMError

###

`prompt (message:String = "", default_:String = ""):String`

Throws:

`null` | DOMError

###

`releaseEvents ():Void`

Releases the window from trapping events of a specific type.

###

`requestAnimationFrame (callback:Float ‑> Void):Int`

Throws:

`null` | DOMError

###

`resizeBy (x:Int, y:Int):Void`

Throws:

`null` | DOMError

###

`resizeTo (x:Int, y:Int):Void`

Throws:

`null` | DOMError

###

`scroll (?options:ScrollToOptions):Void`

`scroll (x:Float, y:Float):Void`

###

`scrollBy (?options:ScrollToOptions):Void`

`scrollBy (x:Float, y:Float):Void`

###

`scrollByLines (numLines:Int, ?options:ScrollOptions):Void`

Scrolls the document by the given number of lines.

###

`scrollByPages (numPages:Int, ?options:ScrollOptions):Void`

Scrolls the current document by the specified number of pages.

###

`scrollTo (?options:ScrollToOptions):Void`

`scrollTo (x:Float, y:Float):Void`

###

`setInterval (handler:String, ?timeout:Int, unused:Rest<Dynamic>):Int`

`setInterval (handler:Function, ?timeout:Int, arguments:Rest<Dynamic>):Int`

Throws:

`null` | DOMError

###

`setResizable (resizable:Bool):Void`

Toggles a user's ability to resize a window.

###

`setTimeout (handler:String, timeout:Int = 0, unused:Rest<Dynamic>):Int`

`setTimeout (handler:Function, timeout:Int = 0, arguments:Rest<Dynamic>):Int`

Throws:

`null` | DOMError

###

`sizeToContent ():Void`

Throws:

`null` | DOMError

###

`stop ():Void`

Throws:

`null` | DOMError

###

`updateCommands (action:String, ?sel:Selection, reason:Int = 0):Void`

Updates the state of commands of the current chrome window (UI).

### Inherited Variables

### Inherited Methods

#### Defined by EventTarget

###

`addEventListener (type:String, listener:Function, capture:Bool = false):Void`

`addEventListener (type:String, listener:EventListener, capture:Bool = false, ?wantsUntrusted:Bool):Void`

Throws:

`null` | DOMError

###

`dispatchEvent (event:Event):Bool`

Throws:

`null` | DOMError

###

`removeEventListener (type:String, listener:Function, capture:Bool = false):Void`

`removeEventListener (type:String, listener:EventListener, capture:Bool = false):Void`

Throws:

`null` | DOMError